<?php


namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Facades\DB;

class Log extends Model
{
    protected $table = 'logs';

    protected $guarded = ['id'];

    public static function getJobProgression(Wowa $wowa)
    {
        $logs =  self::where('job_id', '=', $wowa->id)->orderBy('progression', 'desc')->first();
        if (!is_object($logs)) {
            return "Calculation in progress...";
        }
        if ($wowa->status == Wowa::STATE_COLLECTION) {
            $log = self::where('job_id', '=', $wowa->id)
                ->where('training', '=', false)->orderBy('progression', 'desc')->first();
            return $log->progression;
        } elseif ($wowa->status == Wowa::STATE_RUNNING || $wowa->status == Wowa::STATE_SUCCESS) {
            $log = self::where('job_id', '=', $wowa->id)
                ->where('training', '=', true)->orderBy('progression', 'desc')->first();
            return ((($log->progression + 1) / $wowa->generation_number) * 100);
        } else {
            return 'Error';
        }
    }
}
